unitDef = {
  unitname               = [[abductor]],
  name                   = [[Abductor]],
  description            = [[Gotta Catch Them All!]],
  acceleration           = 1.6,
  amphibious             = true,
  airStrafe              = 0,
  brakeRate              = 1.61,
  buildCostEnergy        = 2500,
  buildCostMetal         = 2500,
  builder                = false,
  buildPic               = [[gunshipheavytrans.png]],
  buildTime              = 2000,
  canAttack              = true,
  canFly                 = true,
  canGuard               = true,
  canload                = [[1]],
  canMove                = true,
  canPatrol              = true,
  canstop                = [[1]],
  canSubmerge            = false,
  category               = [[GUNSHIP]],
  collide                = false,
  collisionVolumeOffsets = [[0 0 0]],
  collisionVolumeScales  = [[60 25 100]],
  collisionVolumeTest    = 1,
  collisionVolumeType    = [[Box]],
  corpse                 = [[DEAD]],
  cruiseAlt              = 250,

  customParams           = {
	helptext       = [[One word: A L I E N S. This light scout ship is  unmanned. Intelligence has determined it has one purpose: stealing units.. but why would it do such a thing? Who would program such a device? Perhaps one day we will know. I WANT TO BELIEVE.]],
	midposoffset   = [[0 0 0]],
	aimposoffset   = [[0 10 0]],
	modelradius    = [[15]],
  },

  explodeAs              = [[ATOMIC_BLAST]],
  floater                = true,
  footprintX             = 4,
  footprintZ             = 4,
  hoverAttack            = true,
  iconType               = [[airtransportbig]],
  idleAutoHeal           = 80,
  idleTime               = 30,
  maneuverleashlength    = [[1280]],
  mass                   = 130,
  maxDamage              = 2000,
  maxVelocity            = 10,
  minCloakDistance       = 200,
  noChaseCategory        = [[TERRAFORM FIXEDWING SATELLITE SUB]],
  objectName             = [[largeTransport.s3o]],
  script		 		 = [[gunshipheavytrans.lua]],
  releaseHeld            = true,
  seismicSignature       = 0,
  selfDestructAs         = [[ABDUCTOR_DEATH]],
  selfDestructCountdown  = 0,

  sfxtypes               = {

    explosiongenerators = {
      [[custom:VINDIMUZZLE]],
      [[custom:VINDIBACK]],
      [[custom:BEAMWEAPON_MUZZLE_RED]],
    },

  },

  side                   = [[CORE]],
  sightDistance          = 1000,
  smoothAnim             = true,
  transportCapacity      = 1,
  transportSize          = 25,
  turninplace            = 1,
  turnRate               = 800,
  upright                = true,
  verticalSpeed          = 30,
  workerTime             = 0,

  weapons                = {

	{
      def                = [[LASER]],
      onlyTargetCategory = [[LAND SHIP SWIM FLOAT HOVER]],
      mainDir            = [[-1 -1 1]],
    },
    {
      def                = [[LASER]],
      onlyTargetCategory = [[LAND SHIP SWIM FLOAT HOVER]],
      mainDir            = [[-1 -1 1]],
    },
    {
      def                = [[ARMFLAK_GUN]],
      onlyTargetCategory = [[FIXEDWING GUNSHIP]],
      mainDir            = [[0 -1 1]],
    },

  },


  weaponDefs             = {

    LASER = {
      name                    = [[Abduction Beam]],
      areaOfEffect            = 8,
      beamTime                = 0.1,
      coreThickness           = 0.4,
      craterBoost             = 0,
      craterMult              = 0,

	  customparams = {
		stats_hide_damage = 1, -- continuous laser
		stats_hide_reload = 1,
	  },

      damage                  = {
        default = 66,
	
      },

      explosionGenerator      = [[custom:FLASH1blue]],
      fireStarter             = 30,
      impactOnly              = true,
      impulseBoost            = 0,
      impulseFactor           = 0.4,
      interceptedByShieldType = 1,
      largeBeamLaser          = true,
      laserFlareSize          = 2,
      minIntensity            = 1,
      noSelfDamage            = true,
      paralyzer               = true,
      range                   = 500,
      reloadtime              = 1/3,
      rgbColor                = [[math.random() math.random() math.random()]],
      soundStart              = [[weapon/laser/pulse_laser2]],
      soundTrigger            = true,
      sweepfire               = false,
      texture1                = [[largelaser]],
      texture2                = [[flare]],
      texture3                = [[flare]],
      texture4                = [[smallflare]],
      thickness               = 2,
      tolerance               = 5000,
      turret                  = true,
      weaponType              = [[BeamLaser]],
      weaponVelocity          = 900,
    },

	
    ARMFLAK_GUN = {
      name                    = [[Quantum Flak Missile Swarm]],
          areaOfEffect            = 85,
          burst                   = 20,
          burstrate               = 0.10,
          burnblow                = true,
          canattackground         = false,
          cegTag                  = [[missiletrailyellow]],
          craterBoost             = 0,
          craterMult              = 0,
          cylinderTargeting       = 3,
          projectiles             = 2,
     
              customParams            = {
                    isaa = [[1]],
              },
     
          damage                  = {
            default = 8.0,
            planes  = 80,
            subs    = 8.0,
          },
     
          edgeEffectiveness       = 0.75,
          explosionGenerator      = [[custom:sonic]],
          fireStarter             = 100,
          flightTime              = 1.25,
          impactOnly              = false,
          impulseBoost            = -35,
          impulseFactor           = -1.4,
          interceptedByShieldType = 2,
          lineOfSight             = false,
          metalpershot            = 0,
          model                   = [[wep_m_fury.s3o]],
          noSelfDamage            = true,
          range                   = 800,
          reloadtime              = 6.0,
     	  renderType              = 1,
     	  selfprop                = true,
     	  smokedelay              = [[0.1]],
    	  smokeTrail              = true,
     	  soundHit                = [[weapon/cannon/mini_cannon]],
          soundhitvolume 	  = 25,
     	  soundStart              = [[weapon/missile/rapid_rocket_fire]],
      	  startsmoke              = [[1]],
      	  startVelocity           = 480,
      	  texture2                = [[lightsmoketrail]],
     	  tolerance               = 9000,
     	  tracks                  = true,
      	  turnRate                = 3000,
      	  turret                  = true,
      	  weaponAcceleration      = 260,
     	  weaponTimer             = 3,
     	  weaponType              = [[MissileLauncher]],
     	  weaponVelocity          = 560,
     	  sprayAngle	    	  = 4000,
     	  dance		     	  = 80,
    	--accuracy		  = 250,
     	  wobble		  = 80,
     	  predictBoost	      = 1,
        --trajectoryHeight	      = 0.25,
    },
    
    ABDUCTOR_DEATH = {
      areaOfEffect       = 620,
      craterBoost        = 6,
      craterMult         = 6,
      edgeEffectiveness  = 0.2,
      explosionGenerator = "custom:ANTINUKE",
      explosionSpeed     = 10,
      impulseBoost       = 2000,
      impulseFactor      = 40,
      name               = "Pulse Fusion Reactor Overload",
      soundHit           = "bigexplo.ogg",
      damage = {
	default          = 500,
      },
    },
  },


  featureDefs            = {

    DEAD  = {
      description      = [[Wreckage - Abductor]],
      blocking         = true,
      category         = [[corpses]],
	  collisionVolumeScales  = [[60 40 80]],
	  collisionVolumeTest	 = 1,
	  collisionVolumeType    = [[CylZ]],
      damage           = 100,
      energy           = 0,
      featureDead      = [[HEAP]],
      footprintX       = 2,
      footprintZ       = 2,
      height           = [[40]],
      hitdensity       = [[100]],
      metal            = 400,
      object           = [[heavytrans_d.dae]],
      reclaimable      = true,
      reclaimTime      = 400,
    },


    HEAP  = {
      description      = [[Debris - Abductor]],
      blocking         = false,
      category         = [[heaps]],
      damage           = 1100,
      energy           = 0,
      footprintX       = 2,
      footprintZ       = 2,
      height           = [[4]],
      hitdensity       = [[100]],
      metal            = 100,
      object           = [[debris3x3c.s3o]],
      reclaimable      = true,
      reclaimTime      = 100,
    },

  },

}

return lowerkeys({ abductor = unitDef })