unitDef = {
  unitname            = [[aliengunship]],
  name                = [[A L I E N Fighter]],
  description         = [[I WANT TO BELIEVE]],
  acceleration        = 0.3,
  activateWhenBuilt   = true,
  brakeRate           = 0.3,
  buildCostMetal      = 2000,
  buildPic            = [[amphassault.png]],
  canFly                 = true,
  canGuard               = true,
  canMove                = true,
  canPatrol              = true,
  canSubmerge = false,
  maxRudder = 0.016,
  sightDistance          = 750,
  speedToFront = 0.5,
  category            = [[FIXEDWING]],
  cruiseAlt           = 100,
  
  collisionVolumeOffsets  = [[0 0 0]],
  --collisionVolumeScales   = [[70 70 70]],
  --collisionVolumeType	  = [[ellipsoid]],
  corpse              = [[DEAD]],

  customParams        = {
    amph_regen = 40,
    amph_submerged_at = 40,
	sink_on_emp    = 0,
    floattoggle    = [[1]],
    aimposoffset   = [[0 30 0]],
    midposoffset   = [[0 0 0]],
    modelradius    = [[42]],
  },

  explodeAs           = [[BIG_UNIT]],
  footprintX          = 4,
  footprintZ          = 4,
  iconType            = [[amphassault]],
  idleAutoHeal        = 55,
  idleTime            = 1800,
  maxDamage           = 1400,
  maxVelocity         = 7.5,
  maxReverseVelocity  = 0,
  minCloakDistance    = 875,
  movementClass       = [[AKBOT4]],
  noChaseCategory     = [[TERRAFORM FIXEDWING SUB]],
  objectName          = [[amphassault.s3o]],
  script              = [[amphassault.lua]],
  selfDestructAs      = [[BIG_UNIT]],

  sfxtypes            = {

    explosiongenerators = {
      [[custom:watercannon_muzzle]],
    },

  },

  sightDistance       = 660,
  sonarDistance       = 660,
  trackOffset         = 0,
  trackStrength       = 8,
  trackStretch        = 1,
  trackType           = [[ComTrack]],
  trackWidth          = 66,
  turnRate            = 500,
upright = false,

  sfxtypes            = {

    explosiongenerators = {
      [[custom:RAIDMUZZLE]],
      [[custom:LEVLRMUZZLE]],
      [[custom:RIOT_SHELL_L]],
    },

  },
  sightDistance       = 500,
  turninplace         = 0,
  turnRate            = 442,
  workerTime          = 0,

  weapons             = {

    {
      def                = [[vehriot_WEAPON]],
      badTargetCategory  = [[FIXEDWING]],
      onlyTargetCategory = [[FIXEDWING LAND SINK TURRET SHIP SWIM FLOAT GUNSHIP HOVER]],
    },

  },


  weaponDefs          = {

    vehriot_WEAPON = {
      name                    = [[Linked Impulse Cannon]],
      areaOfEffect            = 144,
      avoidFeature            = true,
      avoidFriendly           = true,
      burnblow                = true,
      craterBoost             = 1,
      craterMult              = 0.5,

      customParams            = {
        reaim_time = 8, -- COB
        gatherradius = [[90]],
        smoothradius = [[60]],
        smoothmult   = [[0.08]],

		light_camera_height = 1500,
      },
	  
      damage                  = {
        default = 6,
      },

      edgeEffectiveness       = 0.5,
      explosionGenerator      = [[custom:FLASH64]],
      impulseBoost            = 100,
      impulseFactor           = 2.0,
      interceptedByShieldType = 1,
      noSelfDamage            = true,
      range                   = 420,
      reloadtime              = 1/30,
      soundHit                = [[weapon/cannon/generic_cannon]],
      soundStart              = [[weapon/cannon/outlaw_gun]],
      soundStartVolume        = 1,
      turret                  = true,
      weaponType              = [[Cannon]],
      weaponVelocity          = 650,
    },

  },


  featureDefs         = {

    DEAD  = {
      blocking         = false,
      featureDead      = [[HEAP]],
      footprintX       = 2,
      footprintZ       = 2,
      object           = [[leveler_d.dae]],
    },

    HEAP  = {
      blocking         = false,
      footprintX       = 2,
      footprintZ       = 2,
      object           = [[debris2x2a.s3o]],
    },

  },

}

return lowerkeys({ aliengunship = unitDef })